HDU - 2457 DNA repair

Description

Biologists finally invent techniques of repairing DNA that contains segments causing kinds of inherited diseases. For the sake of simplicity, a DNA is represented as a string containing characters 'A', 'G' , 'C' and 'T'. The repairing techniques are simply to change some characters to eliminate all segments causing diseases. For example, we can repair a DNA "AAGCAG" to "AGGCAC" to eliminate the initial causing disease segments "AAG", "AGC" and "CAG" by changing two characters. Note that the repaired DNA can still contain only characters 'A', 'G', 'C' and 'T'. 

You are to help the biologists to repair a DNA by changing least number of characters.
 

Input

The input consists of multiple test cases. Each test case starts with a line containing one integers N (1 ≤ N ≤ 50), which is the number of DNA segments causing inherited diseases. 
The following N lines gives N non-empty strings of length not greater than 20 containing only characters in "AGCT", which are the DNA segments causing inherited disease. 
The last line of the test case is a non-empty string of length not greater than 1000 containing only characters in "AGCT", which is the DNA to be repaired. 

The last test case is followed by a line containing one zeros.
 

Output

For each test case, print a line containing the test case number( beginning with 1) followed by the 
number of characters which need to be changed. If it's impossible to repair the given DNA, print -1.
 

Sample Input

     
     
2 AAA AAG AAAG 2 A TG TGAATG 4 A G C T AGT 0
 

Sample Output

     
     
Case 1: 1 Case 2: 4 Case 3: -1
 

题意: 给出一些不合法的模式DNA串,给出一个原串,问最少需要修改多少个字符,使得原串中不包含非法串
思路:首先我们构造一个AC自动机,然后为了保证不匹配到子串所以我们规定不走到每个子串的尾,然后就是在除了不能走的位置的DP,设dp[i][j]表示母串走到第i个单词,自动机匹配到j的状态的最小值,在保证了不会匹配的前提下,那么遇到一个不相同的字母的时候,我们需要修改子串使得与母串相同,相同的话就不改了,我们现在是尽量往母串改。

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <queue>
using namespace std;
const int inf = 0x3f3f3f3f;

struct Trie {
    int next[1010][4], fail[1010];
    int end[1010];
    int root, L;

    int newNode() {
        for (int i = 0; i < 4; i++)
            next[L][i] = -1;
        end[L++] = false;
        return L-1;
    }

    void init() {
        L = 0;
        root = newNode();
    }

    int getInt(char ch) {
        if (ch == 'A') return 0;
        else if (ch == 'C') return 1;
        else if (ch == 'G') return 2;
        else if (ch == 'T') return 3;
    }

    void insert(char buf[]) {
        int len = strlen(buf);        
        int now = root;
        for (int i = 0; i < len; i++) {
            if (next[now][getInt(buf[i])] == -1)
                next[now][getInt(buf[i])] = newNode();
            now = next[now][getInt(buf[i])];
        }
        end[now] = 1;
    }

    void build() {
        queue<int> Q;
        fail[root] = root;
        for (int i = 0; i < 4; i++) {
            if (next[root][i] == -1) 
                next[root][i] = root;
            else {
                fail[next[root][i]] = root;
                Q.push(next[root][i]);
            }
        }

        while (!Q.empty()) {
            int now = Q.front();
            Q.pop();
            if (end[fail[now]]) end[now] = 1; //notice
            for (int i = 0; i < 4; i++) 
                if (next[now][i] == -1)
                    next[now][i] = next[fail[now]][i];
                else {
                    fail[next[now][i]] = next[fail[now]][i];
                    Q.push(next[now][i]);
                }
        }
    }
    int dp[1010][1010];
    int solve(char buf[]) {
        int len = strlen(buf);
        for (int i = 0; i <= len; i++)
            for (int j = 0; j < L; j++)
                dp[i][j] = inf;

        dp[0][root] = 0;
        for (int i = 0; i < len; i++) 
            for (int j = 0; j < L; j++) 
                if (dp[i][j] != inf) {
                    for (int k = 0; k < 4; k++) {
                        int news = next[j][k];
                        if (end[news]) continue;
                        int tmp;
                        if (k == getInt(buf[i]))
                            tmp = dp[i][j];
                        else tmp = dp[i][j] + 1;
                        dp[i+1][news] = min(dp[i+1][news], tmp);
                    }
                }

        int ans = inf;
        for (int j = 0; j < L; j++)
            ans = min(ans, dp[len][j]);
        if (ans == inf) 
            ans = -1;
        return ans;
    }
} ac;
char buf[1010];

int main() {
    int n, cas = 1;
    while (scanf("%d", &n) != EOF && n) {
        ac.init();
        while (n--) {
            scanf("%s", buf);
            ac.insert(buf);
        }

        ac.build();
        scanf("%s", buf);
        printf("Case %d: %d\n", cas++, ac.solve(buf));
    }
    return 0;
}
  • 1
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值